﻿//////////////////////////////////////////////
// ProfilableClass.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "ProfilingHelper.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkGraphics
{
	typedef enum
	{
		PROFILING_DATA_TIME = 0,
		PROFILING_DATA_STATISTICS
	} ProfilableData ;

	class DLL_GRAPHICS_EXPORT ProfilableClass
	{
		private :
		
			// Il nous faut un Helper associé
			ProfilingHelper* _helper ;

			// Savoir si on profile
			bool _hasToProfile ;
			
		public :
		
			// Constructeur, destructeur
			ProfilableClass () ;
			virtual ~ProfilableClass () ;

			// Les fonctions liées
			void prepareProfiling () ;
			void endProfiling () ;

			// Setters
			void setHasToProfile (bool value, gpuAnswerCallback toCall) ;
			void setDataToProfile (bool value, ProfilableData toTrack) ;

			// Getters
			ProfilingInfosHolder* getLastProfiledData () const ;
	} ;
}