﻿//////////////////////////////////////////////
// ConstantBuffer.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Buffer ;
	class ShaderPassMemorySlot ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

// nkExport
#include <NilkinsExport/Exportable/Exportable.h>

// Standards
#include <vector>

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT ConstantBuffer : public nkExport::Exportable
	{
		protected :

			// Fonctions
			virtual ShaderPassMemorySlot* allocatePassMemorySlot () = 0 ;

		protected :
		
			// Attributs
			// Les slots
			std::vector<ShaderPassMemorySlot*> _slots ;

			// Si besoin recalculer
			bool _dirtyData ;

		public :
		
			// Constructeur, destructeur
			ConstantBuffer () ;
			virtual ~ConstantBuffer () ;

			// Getters
			ShaderPassMemorySlot* getPassMemorySlot (unsigned int index) ;
			ShaderPassMemorySlot* getPassMemorySlotReadOnly (unsigned int index) const ;

			// Manipulations slots
			ShaderPassMemorySlot* addPassMemorySlot () ;
			void changePassMemorySlotOrder (unsigned int fromIndex, unsigned int toIndex) ;
			void deletePassMemorySlot (unsigned int index) ;

			// Pour l'update
			virtual void checkBuffer () = 0 ;
			virtual void fillBuffer () = 0 ;

			// L'export et import
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}