﻿//////////////////////////////////////////////
// Endianness.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Internals --------------------------------

namespace nkImages
{
	enum class ENDIAN
	{
		LITTLE_ENDIAN = 0,
		BIG_ENDIAN
	} ;
}

/// Includes ---------------------------------

// Standards
#include <inttypes.h>

/// Class ------------------------------------

namespace nkImages
{
	class Endianness final
	{
		private :

			// Constructorr, destructorr
			Endianness () ;
			~Endianness () ;

		public :

			static ENDIAN getEndianness ()
			{
				union
				{
					char c [4] ;
					uint32_t i = 0x00111155 ;
				} data ;

				return data.c[0] == 0x55 ? ENDIAN::LITTLE_ENDIAN : ENDIAN::BIG_ENDIAN ;
			}
	} ;
}