//////////////////////////////////////////////
// ExecutionResult.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// Standards
#include <string>

/// Class ------------------------------------

namespace nkScripts
{
	enum class EXECUTION_FAILURE_TYPE
	{
		NO_ERROR = 0,
		UNKNOWN,
		INTERPRETER_UNKNOWN,
		INTERPRETER_TYPE_MISMATCH,
		BYTECODE_NOT_READY,
		RUNTIME,
		MEMORY_ALLOCATION
	} ;

	struct ExecutionResult final
	{
		// Erreur si failure
		std::string _failureMessage ;
		// Failure type si elligible
		EXECUTION_FAILURE_TYPE _failureType = EXECUTION_FAILURE_TYPE::NO_ERROR ;

		// Si failure il y a eu
		bool _success = true ;
	} ;
}