﻿//////////////////////////////////////////////
// DummyEnvironmentStrategy.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkScripts
#include "EnvironmentStrategy.h"

/// Class ------------------------------------

namespace nkScripts
{
	class DummyEnvironmentStrategy final : public EnvironmentStrategy
	{
		public :

			// Constructeur, destructeur
			DummyEnvironmentStrategy (Environment* parentEnv) ;
			~DummyEnvironmentStrategy () ;

			// Exécution
			virtual bool execute (const Script& script) override ;
			virtual void requestGarbageCollection () override ;
			virtual void shutdown () override ;

			// Set mémoire env
			virtual void setVar (const char* name, bool value) override ;
			virtual void setVar (const char* name, int value) override ;
			virtual void setVar (const char* name, float value) override ;
			virtual void setVar (const char* name, double value) override ;
			virtual void setVar (const char* name, const char* value) override ;
			virtual void setVar (const char* name, const ScriptObjectReference& value) override ;
			virtual void setObject (const char* name, const char* userType, void* value) override ;

			virtual bool isSet (const char* name) override ;

			virtual bool getVar (const char* name, bool defaultValue) override ;
			virtual int getVar (const char* name, int defaultValue) override ;
			virtual float getVar (const char* name, float defaultValue) override ;
			virtual double getVar (const char* name, double defaultValue) override ;
			virtual const char* getVar (const char* name, const char* defaultValue) override ;
			virtual ScriptObjectReference getVar (const char* name) override ;
			virtual void* getObject (const char* name, const char* userType) override ;
			virtual ScriptObjectReference getScriptFunction (const char* name) override ;

			// Functions
			virtual Function* setFunc (const char* name) override ;

			// UserTypes
			virtual UserType* setUserType (const char* name) override ;

			// Namespaces
			virtual Namespace* setNamespace (const char* name) override ;

			// Call C++ -> Script
			virtual bool callScriptFunction (const ScriptObjectReference& reference, const DataStack& args, DataStack& expectedOutput) override ;
			virtual nkMemory::Buffer serializeScriptObject (const ScriptObjectReference& reference, bool forwardUserDataOwnership) override ;
			virtual ScriptObjectReference deserializeScriptObject (const nkMemory::BufferView<unsigned char>& object) override ;
	} ;
}