﻿//////////////////////////////////////////////
// ContentLoader.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkExport
{
	class Exportable ;
	class Node ;
}

/// Includes ---------------------------------

// nkScripts
#include "../Dll/DllDefines.h"

#include "ContentLoadResult.h"

// nkExport
#include <NilkinsExport/Exporter/ExporterLoadResult.h>

/// Class ------------------------------------

namespace nkScripts
{
	class DLL_SCRIPTS_EXPORT ContentLoader final
	{
		private :

			ContentLoader () = delete ;
			~ContentLoader () = delete ;

		public :

			// Ces fonctions sont dupliquées depuis nkGraphics
			// Il faudrait voir si ça ne serait pas un bon plan de les factoriser dans nkExport (TODO)
			// Fonctions pratiques
			static nkExport::ExporterLoadResult inputData (const std::string_view& filePath) ;
			static std::string inputDataStr (const std::string_view& filePath) ;
			static nkExport::ExporterLoadResult inputDataSources (const std::string_view& sources) ;
			static bool outputData (const std::string_view& content, const std::string_view& path) ;

			// Save
			static bool saveTreeDeclaration (nkExport::Node* tree, const std::string_view& pathFromData) ;
			static bool saveObjectDeclaration (nkExport::Exportable* object, const std::string_view& pathFromData) ;

			// Scripts
			static ContentLoadResultScript loadScriptDeclaration (const std::string_view& pathFromData, bool loadResource = true) ;
			static ContentLoadResultScript processScriptSources (const std::string_view& sources, bool loadResource = true) ;
			static ContentLoadResultScript processScriptTree (nkExport::Node* tree, bool loadResource = true) ;
	} ;
}