﻿//////////////////////////////////////////////
// MenuBar.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkWinUi
{
	class Component ;
}

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

// nkExport
#include <NilkinsExport/Exportable/Exportable.h>

// Standards
#include <map>
#include <string>

/// Class ------------------------------------
	
namespace nkWinUi
{
	class DLL_WINUI_EXPORT MenuBar : public nkExport::Exportable
	{
		protected :
		
			// Attributs
			// Window mère
			Component* _parentWin ;
		
		public :
		
			// Constructeur, destructeur
			MenuBar () ;
			virtual ~MenuBar () ;

			// Getter
			Component* getParentComponent () const ;

			// Setter
			void setParentComponent (Component* parent) ;

			// Manipulations
			virtual void addMenu (const char* label) = 0 ;
			virtual void addMenuItem (const char* menuLabel, const char* itemLabel, int attachedIndex) = 0 ;
			virtual void addSeparator (const char* menuLabel) = 0 ;

			// Import / Export
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}