//////////////////////////////////////////////
// ScrollBar.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT ScrollBar : public Component
	{
		protected :

			// Bornes
			int _min ;
			int _max ;

			// Avancement actuel
			int _currentMin ;
			int _currentMax ;

		public :
	
			// Constructeur, destructeur
			ScrollBar () ;
			~ScrollBar () ;

			// Getters
			int getCurrentMin () const ;
			int getCurrentMax () const ;

			// Setters
			void setMin (int value) ;
			void setMax (int value) ;
			void setActiveRange (int value) ;
			virtual void scrollToMin () ;
			virtual void scrollToMax () ;
			virtual void setScrollFactor (float value) = 0 ;
			virtual void moveCurrentMinTo (int value) ;
			virtual void moveCurrentMaxTo (int value) ;

			// Helpers
			virtual void scroll (float factor) = 0 ;
	} ;
}